ash: builtin: Mark more regular built-ins
[oweals/busybox.git] / shell / hush_test / run-all
1 #!/bin/sh
2
3 unset LANG LANGUAGE
4 unset LC_COLLATE
5 unset LC_CTYPE
6 unset LC_MONETARY
7 unset LC_MESSAGES
8 unset LC_NUMERIC
9 unset LC_TIME
10 unset LC_ALL
11
12 TOPDIR=`pwd`
13
14 if test ! -x hush; then
15         if test ! -x ../../busybox; then
16                 echo "Can't run tests. Put hush binary into this directory (`pwd`)"
17                 exit 1
18         fi
19         echo "No ./hush - creating a link to ../../busybox"
20         ln -s ../../busybox hush
21 fi
22 if test ! -f .config; then
23         if test ! -f ../../.config; then
24                 echo "Missing .config file"
25                 exit 1
26         fi
27         cp ../../.config . || exit 1
28 fi
29
30 eval $(sed -e '/^#/d' -e '/^$/d' -e 's:^:export :' .config)
31
32 PATH="`pwd`:$PATH" # for hush and recho/zecho/printenv
33 export PATH
34
35 THIS_SH="`pwd`/hush"
36 export THIS_SH
37
38 do_test()
39 {
40         test -d "$1" || return 0
41         d=${d%/}
42 #       echo Running tests in directory "$1"
43         # $1 but with / replaced by # so that it can be used as filename part
44         noslash=`echo "$1" | sed 's:/:#:g'`
45         (
46         tret=0
47         cd "$1" || { echo "cannot cd $1!"; exit 1; }
48         for x in run-*; do
49                 test -f "$x" || continue
50                 case "$x" in
51                         "$0"|run-minimal|run-gprof) ;;
52                         *.orig|*~) ;;
53                         #*) echo $x ; sh $x ;;
54                         *)
55                         echo -n "$1/$x:"
56                         sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \
57                         { { echo " ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo " fail"; }
58                         ;;
59                 esac
60         done
61         # Many bash run-XXX scripts just do this,
62         # no point in duplication it all over the place
63         for x in *.tests; do
64                 test -x "$x" || continue
65                 name="${x%%.tests}"
66                 test -f "$name.right" || continue
67 #               echo Running test: "$x"
68                 echo -n "$1/$x:"
69                 (
70                         "$THIS_SH" "./$x" >"$name.xx" 2>&1
71                         r=$?
72                         # filter C library differences
73                         sed -i \
74                                 -e "/: invalid option /s:'::g" \
75                                 "$name.xx"
76                         test $r -eq 77 && rm -f "$TOPDIR/$noslash-$x.fail" && exit 77
77                         diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \
78                         && rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail"
79                 )
80                 case $? in
81                         0)  echo " ok";;
82                         77) echo " skip (feature disabled)";;
83                         *)  echo " fail ($?)"; tret=1;;
84                 esac
85         done
86         exit ${tret}
87         )
88 }
89
90 # Main part of this script
91 # Usage: run-all [directories]
92
93 ret=0
94
95 if [ $# -lt 1 ]; then
96         # All sub directories
97         modules=`ls -d hush-*`
98
99         for module in $modules; do
100                 do_test $module || ret=1
101         done
102 else
103         while [ $# -ge 1 ]; do
104         if [ -d $1 ]; then
105                 do_test $1 || ret=1
106         fi
107         shift
108         done
109 fi
110
111 exit ${ret}